export default {}

/**
 * @template T, R
 * @typedef {(value: T) => R} Morphism
 */

/**
 * @template T
 * @typedef {<R>(value: T) => R} InferredMorphism
 */

/**
 * @template T
 * @typedef {(value: T) => boolean} Predicate
 */

/**
 * @template T
 * @typedef {(value: T) => Chain<T>} ChainConstructor
 */

/**
 * @template T
 * @typedef {<R>(f: Morphism<T, R>) => R} chain
 */

/**
 * @template T
 * @typedef {{ chain: chain<T> }} Chain
 */

/** @typedef {(...args: any[]) => any} Fn */
